package org.lantsovanton.abstraction.model;

import org.lantsovanton.abstraction.model.impl.Chip;
import org.lantsovanton.abstraction.model.impl.Coordinate;
import org.lantsovanton.abstraction.model.impl.Move;
import org.lantsovanton.abstraction.model.impl.Position;
import org.lantsovanton.abstraction.model.impl.PsevdoMove;
import org.lantsovanton.abstraction.model.impl.RandomIntellect;

public class Factory {
	/**
	 * 
	 * @param h
	 * @param l
	 * @param player
	 * @return
	 */
	public IPosition initialPosition(int h,int l,int player){
		return new Position( h, l, player ); 		
	}
	
	/**
	 * 
	 * @param h
	 * @param l
	 * @param player
	 * @return
	 */
	public IMove initialSimpleMove( int h, int l ,int player ){
		return new Move( h, l, player ); 
	}
	
	public IMove initialPsevdoMove( int player ){
		 return new PsevdoMove();
	}
	
	public IChip initialChip( int player ){
		return new Chip( player );
	}
	
	/**
	 * 
	 * @param x
	 * @param y
	 * @return
	 */
	public ICoordinate initialCoordinate( int x, int y ){
		return new Coordinate( y, x );
	}
	
	public Intellect initialRandomIntellect(){ 
		return new RandomIntellect();
	}
	

}
