package org.lantsovanton.abstraction.model;




public interface IGame {
	
	/**
	 * 
	 * @param position
	 * @param player
	 * @return true if game is finish and player (in parameter) is winner
	 */
	public boolean isWinner( IPosition position, int player );
	
	/**
	 * 
	 * @param myPosition
	 * @param move
	 * @return true if move is possible in this pposition
	 */
	public boolean isMovePosible( IPosition myPosition, IMove move );
	
	/**
	 * do move in position
	 * @param position
	 * @param move
	 * 
	 */
	public void doMove( IPosition position, IMove move );
	
	/**
	 * 
	 * @return start position of this game
	 */
	public IPosition initialPosition();
	
	/**
	 * 
	 * @param position
	 * @return true if game is finish 
	 */
	public boolean isGameFinish( IPosition position);
    
	/**
     *  
     * @param position
     * @param coordinate
     * @return move for this game or PsevdoMove if move not completion 
     * null if move uncorrect 
     */
	public IMove getMove( IPosition position, ICoordinate coordinate );
	
	/**
	 * do move in clone of position
	 * @param position
	 * @param move
	 * @return clone of position after  
	 */
	public IPosition tryMove( IPosition position, IMove move );
    
	/**
     * 
     * @return name  of this game
     */	
	public String getName();
	
	/**
	 * 
	 * @return intellect for this game
	 */
	public Intellect initialIntellect();

}
