package org.lantsovanton.abstraction.ui;


import java.awt.Color;
import java.awt.Graphics;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;




import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.SwingUtilities;

import org.lantsovanton.abstraction.model.Factory;
import org.lantsovanton.abstraction.model.ICoordinate;
import org.lantsovanton.abstraction.model.IGame;
import org.lantsovanton.abstraction.model.IListener;
import org.lantsovanton.abstraction.model.IMove;
import org.lantsovanton.abstraction.model.IPosition;
import org.lantsovanton.abstraction.model.Intellect;




public class GameComponent2 extends JComponent {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private int myField = 60;
	private int myHight;
	private int myWidth;
	private Intellect  myIntellect;
	private IGame myGame;
	private IPosition myPosition;
	private PositionListener myListener;
    private Graphics myGraphics;
    private int myState = 1;
    private int myH;
    private int myL;
    private boolean myBeautiful = true;
    private Factory myFactory = new Factory(); 
	/**
	 * 
	 */
	
    
    
	public GameComponent2(Intellect  intellect, IGame game, IPosition position ) {		
		super();
		myIntellect = intellect; 
		myGame = game;
		myPosition = position;
		myListener = new PositionListener();
		myPosition.addListener( myListener );
		myHight = myPosition.getHight();
		myWidth = myPosition.getWidth();
		this.addMouseListener( new GameComponentMouseListener() );
		
	}
	
	public boolean isBeautiful(){
		return myBeautiful;
	}
	
	private void drawChip(Graphics g, int h, int l, Color c  ){
		
		if( myBeautiful ){
			g.setColor(c);
			g.fillArc(l*myField + myField/6,h*myField+ myField/6,myField*2 /3 ,myField*2 /3,90,180 );
			g.setColor(Color.WHITE);
			g.fillArc(l*myField+ myField/6,h*myField+ myField/6,myField*2 /3,myField*2 /3,270,180 );
			g.fillOval(l*myField+ myField/3,myField /3 +h*myField+ myField/6,myField /3,myField /3 );
			g.setColor(c);
			g.fillOval(l*myField+ myField/3, +h*myField+ myField/6,myField /3,myField /3 );
		}else{
			g.setColor(c);
			g.fillOval(l*myField + myField/6,h*myField+ myField/6,myField*2 /3 ,myField*2 /3 );
		}
		
	}
 	
	public void setBeautiful( boolean beauty ){
		myBeautiful = beauty;
		repaint();
	}
	
	public void paintComponent( Graphics g){
		
		
		int y = this.getHeight();
		int x = this.getWidth(); 
		 if( y / this.myHight > x / this.myWidth  ){
			 myField = x / this.myWidth;
			
		 }else{
			 myField = y / this.myHight;
		 }
		myGraphics = g;
		int s = myField;//width of field
		g.setColor( Color.WHITE);
		g.fillRect(0,0,this.getWidth(),this.getHeight());
		if( myBeautiful )
		for( int l = 0; l < x; l += x - 1 ){
			for( int h = 0; h < y; h ++ ){
				if( (h+l) % 2 ==0 ){
					g.setColor( Color.GREEN );
				}else{
					g.setColor( Color.ORANGE);
				}
				g.drawLine(x/2,y/2,l,h);
			}
		}
		if( myBeautiful )
		for( int l = 0; l < x; l ++ ){
			for( int h = 0; h < y; h += y-1 ){
				if( (h+l) % 2 ==0 ){
					g.setColor( Color.GREEN );
				}else{
					g.setColor( Color.YELLOW);
				}
				g.drawLine(x/2,y/2,l,h);
			}
		}
		////////////////////////////
		g.setColor( Color.BLACK);	
		for( int i = 0; i <= myWidth; i++ ){
			myGraphics.drawLine( s * i, 0, s * i, myHight * s );
		}
		for( int j = 0; j <= myHight; j++ ){
			myGraphics.drawLine( 0, s * j, myWidth * s, s * j );
		}
		
		for( int h = 0; h < myHight; h++ ){
			for( int l = 0; l < myWidth; l++ ){
				if( myPosition.get( h, l ) != null ){
					if( myPosition.get( h, l ).getPlayer() == 1 ){
						myGraphics.setColor( Color.RED );
						
						drawChip(myGraphics, h,l,Color.RED);
						
					}else{
						myGraphics.setColor( Color.BLUE );
						
						drawChip(myGraphics, h,l,Color.BLUE);
					}
				}
			}
		}
	}
	
	public void newGame(Intellect  intellect, IGame game, IPosition position ){
		myIntellect = intellect; 
		myGame = game;
		myPosition = position;
		myListener = new PositionListener();
		myPosition.addListener( myListener );
		myHight = myPosition.getHight();
		myWidth = myPosition.getWidth();		
		SwingUtilities.invokeLater(new Runnable(){ 
			public void run(){
				repaint();
			}				
		} );
	}
	
	
	public void repaint(Graphics g){
		
		int y = this.getHeight();
		int x = this.getWidth(); 
		 if( y / this.myHight > x / this.myWidth  ){
			 myField = x / this.myWidth;
			
		 }else{
			 myField = y / this.myHight;
		 }
		myGraphics = g;
		int s = myField;//width of field
		g.setColor( Color.WHITE);

		g.fillRect(0,0,this.getWidth(),this.getHeight());
		g.setColor( Color.BLACK);
		for( int i = 0; i <= myWidth; i++ ){
			myGraphics.drawLine( s * i, 0, s * i, myHight * s );
		}
		for( int j = 0; j <= myHight; j++ ){
			myGraphics.drawLine( 0, s * j, myWidth * s, s * j );
		}
		
		for( int h = 0; h < myHight; h++ ){
			for( int l = 0; l < myWidth; l++ ){
				if( myPosition.get( h, l ) != null ){
					if( myPosition.get( h, l ).getPlayer() == 1 ){
						myGraphics.setColor( Color.RED );
						myGraphics.drawOval(  s * l + 1 ,s * h + 1 , s/2, s/2 );
					}else{
						myGraphics.setColor( Color.BLUE );
						myGraphics.drawOval(  s * l + 1, s * h +1 , s/2, s/2 );
					}
				}
			}
		}
		
		if( myState == 2  ){
			myGraphics.setColor( Color.RED );
			myGraphics.drawOval(  s * myL + 1 ,s * myH + 1 , s-5, s-5 );
		}
	
	}
	
	
	private class PositionListener implements IListener{
		public void update() {			
			SwingUtilities.invokeLater(new Runnable(){ 
				public void run(){
					repaint();
				}				
			} );		
		}		
	}
	
	/**
	 * unregister listener
	 */
	public void finalize(){
		myPosition.removeListener( myListener );
	}
	
	private void finishOfGame(){
		String text = "        ";
		if( myGame.isWinner(myPosition,1) ){
			text += "You are winner!";
		}
		if( myGame.isWinner(myPosition,2) ){
			text += "Computer is winner!";
		}
		
		if( ! myGame.isWinner(myPosition,1) && ! myGame.isWinner(myPosition,2) ){
			text += "            Draw...";
		}
		JFrame dialog = new JFrame( " Game over! " );
		JLabel pane = new JLabel( text );
		dialog.add(pane);
		dialog.setSize(200,100);	
		dialog.setLocation(400,400);
		dialog.setVisible(true);
	}
	private class GameComponentMouseListener implements MouseListener{

		public void mouseClicked(MouseEvent arg0) {
		
			if( myState == 3 ){
				return;
			}
			
			int x = arg0.getX() / myField;
			int y = arg0.getY() / myField;			
			ICoordinate coordinate = myFactory.initialCoordinate( x, y );
			IMove move =  myGame.getMove( myPosition, coordinate );
			if( move != null ){
			
				if( !( move.isPsevdoMove() )){
			
					myGame.doMove( myPosition, move );
					repaint();					
					if ( myGame.isGameFinish( myPosition ) ){
						finishOfGame();
					}
					while( myPosition.getPlayer() == 2  && ! myGame.isGameFinish( myPosition ) ){
						myState = 3;
						myGame.doMove( myPosition, myIntellect.go() );
					if ( myGame.isGameFinish( myPosition ) ){
							finishOfGame();
						}
					}
					myState = 1;
					
				}else{
				myState = 2;
				}
			}else{
			}
		}
		
	

		public void mousePressed(MouseEvent arg0) {		
			
		}

		public void mouseReleased(MouseEvent arg0) {
			
			
		}

		public void mouseEntered(MouseEvent arg0) {
			
			
		}

		public void mouseExited(MouseEvent arg0) {
			
			
		}

		
	}
}
