package test.org.lantsovanton;

import org.lantsovanton.abstraction.model.IGame;
import org.lantsovanton.abstraction.model.IPosition;
import org.lantsovanton.abstraction.model.Intellect;
import org.lantsovanton.abstraction.model.impl.Chip;
import org.lantsovanton.abstraction.model.impl.Move;
import org.lantsovanton.games.noughtsandcrosses.NoughtsAndCrosses;
import org.lantsovanton.games.noughtsandcrosses.Random001;


import junit.framework.TestCase;

public class Random001Test extends TestCase {
	public void testwinnextmove(){
		IGame game = new NoughtsAndCrosses();
		IPosition position = game.initialPosition();
		Intellect intellect = new Random001();
		intellect.setPlayer(1);
		intellect.setGame(game);
		intellect.setPosition(position);
		intellect.setRandom(false);
		Move move = new Move(1,1,1);  
		assertEquals(intellect.go(), move );
		
		position.set(0,0, new Chip(2) );
		position.set(1,1, new Chip(2) );
		move = new Move(2,2,1); 
		assertEquals(intellect.go(), move );
		
		
		position.set(0,0, new Chip(1) );
		position.set(1,1, new Chip(1) );
		assertEquals(intellect.go(), move );
	}
	
	public void testbegin(){
		IGame game = new NoughtsAndCrosses();
		IPosition position = game.initialPosition();
		Intellect intellect = new Random001();
		intellect.setPlayer(2);
		intellect.setGame(game);
		intellect.setPosition(position);
		intellect.setRandom(false);
		position.setPlayer(2);
		
		position.set(1,1, new Chip(1));
		Move move = new Move(0,0,2);
		assertEquals(intellect.go(), move );
		
		position.set(1,1, null );
		position.set(0,0, new Chip(1));
		move = new Move(1,1,2);
		assertEquals(intellect.go(), move );
		
		
	}
	
	public void testend(){
		IGame game = new NoughtsAndCrosses();
		IPosition position = game.initialPosition();
		Intellect intellect = new Random001();
		intellect.setPlayer(2);
		intellect.setGame(game);
		intellect.setPosition(position);
		intellect.setRandom(false);
		position.setPlayer(2);
		
		position.set(1,1, new Chip(2));
		position.set(0,0, new Chip(1));
		position.set(2,2, new Chip(1));
		Move move = new Move(0,1,2);
		assertEquals(intellect.go(), move );
		
		position.set(1,1, new Chip(1));
		position.set(0,0, new Chip(2));
		position.set(2,2, new Chip(1));
		
		move = new Move( 0, 2, 2 );
		assertEquals(intellect.go(), move );
	}

}
