package test.org.lantsovanton;

import org.lantsovanton.abstraction.model.IGame;
import org.lantsovanton.abstraction.model.IPosition;
import org.lantsovanton.abstraction.model.Intellect;
import org.lantsovanton.abstraction.model.impl.Move;
import org.lantsovanton.abstraction.model.impl.RandomIntellect;
import org.lantsovanton.games.noughtsandcrosses.NoughtsAndCrosses;
import org.lantsovanton.games.reversi.Reversi;

import junit.framework.TestCase;

public class RandomIntellecttest extends TestCase {
	
	public void testreversi(){
		
		IGame game = new Reversi();
		IPosition position = game.initialPosition();
		Intellect intellect = new RandomIntellect( game, 1, position );
		intellect.setRandom(false);
		Move move = new Move(2, 4, 1);
		assertEquals( (Move)intellect.go(), move );
	}
	
	public void testNoughtandcroses(){ 
		IGame game = new NoughtsAndCrosses();
		IPosition position = game.initialPosition();
		Intellect intellect = new RandomIntellect( game, 1, position );
		intellect.setRandom(false);
		Move move = new Move( 0, 0, 1);
		assertEquals( (Move)intellect.go(), move );
	}

}
